%define name smeserver-joomla
%define version 1.5.1
%define release 2
%define rpmver   4.0.4

Summary:            Joomla Web Application for SME Server 7.x based on Joomla 1.5.1
Name:               %{name}
Version:            %{version}
Release:            %{release}
Copyright:          GPL
Group:              /Web/Applications
Source:             %{name}-%{version}.tar.gz
Packager:           Dietmar Berteld  <dietmar@berteld.com>
URL:                http://joomla.org
BuildRoot:          /var/tmp/%{name}-%{version}-%{release}-buildroot
BuildArchitectures: noarch
Requires:           e-smith-base, e-smith-release >= 7

%description
This RPM is an unofficial addon for the SME Server 7.x.  
The target audience is the Linux/E-smith administrator 
who wants to add CMS-SW.
Joomla! is an award-winning Content Management System (CMS) that 
will help you build websites and other powerful online applications. 
Best of all, Joomla! is an open source solution that is freely available to everybody.
After installation open your webbrowser your local site                                                                                       
http://your_e-smith-server_adress/joomla



%changelog
* Mon Feb 11 2008 Dietmar Berteld <dietmar@berteld.com>
- [1.5.1-2] Change to Joomla 1.5.1 stable

* Wed Nov 14 2007 Dietmar Berteld <dietmar@berteld.com>
- [1.5RC3-1] Initial version

%prep
rm -rf $RPM_BUILD_ROOT

%setup

%build

%install
rm -rf $RPM_BUILD_ROOT
(cd root ; find . -depth -print | cpio -dump $RPM_BUILD_ROOT)
rm -f %{name}-%{version}-filelist
/sbin/e-smith/genfilelist $RPM_BUILD_ROOT > %{name}-%{version}-filelist

%clean
rm -rf $RPM_BUILD_ROOT

%pre
UPDATE=$(ls /opt | grep -c joomla)
case $UPDATE in
  0)
    echo "Installing Joomla... Please wait!"
    ;;
  *)
    echo "Updating Joomla... Please wait!"
    mkdir -p /opt/Joomla_RPM_BACKUP
    cd /opt
    echo "Backing up installation files..."
    tar -czf /opt/Joomla_RPM_BACKUP/joomla.tar.gz joomla
    echo "Backing up MySQL database..."
    mysqldump joomla > /opt/Joomla_RPM_BACKUP/joomla.sql
    /sbin/e-smith/db configuration show joomla > /opt/Joomla_RPM_BACKUP/config.txt
    ;;
esac

%post

# General Information
# General Information
/etc/e-smith/events/actions/initialize-default-databases
# General Information
APP=Joomla
URL=joomla
WORKDIR=/root
INSTALLDIR=/usr/share/doc/Joomla-1.5.1/Sources
HTMLDIR=/opt/joomla
MYSQLDB=joomla
MYSQLUSER=joomlauser
MYSQLPASS=$(/sbin/e-smith/db configuration getprop joomla DbPassword)
DOMAIN=$(/sbin/e-smith/db configuration get DomainName)
SRVNAME=$(/sbin/e-smith/db configuration get SystemName)
UPDATE=$(ls /opt | grep -c joomla)
grep "LANG=" /etc/sysconfig/i18n > lang1
sed -e 's/LANG="//g' lang1 > lang2
sed -e 's/"//g' lang2 > lang
LANG=$(cat lang)
rm -rf lang*
#Untar application
echo "Decompressing files..."
mkdir -p $HTMLDIR
tar xzf $INSTALLDIR/Joomla-1.5.1.tar.gz -C /opt
case $UPDATE in
   0) mv -f /opt/Joomla-1.5.1/* $HTMLDIR ;;
   *) cp -ufR /opt/Joomla-1.5.1/* $HTMLDIR --reply=yes ;;
esac
rm -rf $HTMLDIR/installation
rm -rf /opt/Joomla-1.5.1
#Prepare config settings
if [ "$UPDATE" = "0" ]; then
    sed 's.joomlapassword.'$MYSQLPASS'.g' $INSTALLDIR/configuration.php > $HTMLDIR/configuration2.php
    sed "s/mydomain/$DOMAIN/g" $HTMLDIR/configuration2.php > $HTMLDIR/configuration.php
    rm $HTMLDIR/configuration2.php
fi
chown -R admin.www $HTMLDIR
chmod -R g+w $HTMLDIR
chmod 644 $HTMLDIR/configuration.php
#Creating DataBase
echo "MySQL installation:"
sed -e "s/'admin@mydomain'/'admin@$DOMAINE'/" $INSTALLDIR/joomla.sql > $INSTALLDIR/joomla.sql.new
case $UPDATE in
  0)
    echo "Creating MySQL User and DataBase..."
    mysqladmin -u root create $MYSQLDB
    case "$LANG" in
	de_DE) sed 's.en-GB.de-DE.g' $INSTALLDIR/joomla.sql.new > $INSTALLDIR/joomla.sql ;;
	es_ES) sed 's.en-GB.es-ES.g' $INSTALLDIR/joomla.sql.new > $INSTALLDIR/joomla.sql ;;
	fr_FR) sed 's.en-GB.fr-FR.g' $INSTALLDIR/joomla.sql.new > $INSTALLDIR/joomla.sql ;;
	it_IT) sed 's.en-GB.it-IT.g' $INSTALLDIR/joomla.sql.new > $INSTALLDIR/joomla.sql ;;
	sv_SV) sed 's.en-GB.it-IT.g' $INSTALLDIR/joomla.sql.new > $INSTALLDIR/joomla.sql ;;
	    *) sed 's.en-GB.en-GB.g' $INSTALLDIR/joomla.sql.new > $INSTALLDIR/joomla.sql ;;
    esac
    sed "s/mydomain/$DOMAIN/g" $INSTALLDIR/joomla.sql > $INSTALLDIR/joomla.sql.new
    mysql $MYSQLDB < $INSTALLDIR/$MYSQLDB.sql.new
    mysql -u root -e "SET PASSWORD FOR $MYSQLUSER@localhost = PASSWORD( '$MYSQLPASS' ) "
    mysqladmin flush-privileges
    ;;
  *)
    echo "Fixing MySQL rights..."
    mysql -u root -e "SET PASSWORD FOR $MYSQLUSER@localhost = PASSWORD( '$MYSQLPASS' ) "
    mysqladmin flush-privileges
    ;;
esac
echo "Applying modifications to services..."
/sbin/e-smith/expand-template /etc/httpd/conf/httpd.conf
/usr/local/bin/svc -h /service/httpd-e-smith
echo "-------------------------------------------------------------------------------"
case $UPDATE in
  0)
    echo "$APP Installation completed."
    echo "Reminder:"
    echo "- Website open globally"
    echo "- go to http://$DOMAIN/$URL"
    echo "- Username       : admin"
    echo "- Password       : admin"
    echo "- Please change admin password"
    ;;
  *)
    echo "$APP update completed."
    echo "Reminder:"
    echo "- The old install was backed up and can be found in /opt/Joomla_RPM_BACKUP"
    echo "  PLEASE MOVE THIS DIRECTORY TO A SAFE PLACE!!!"
    echo "- Website open globally"
    echo "- go to http://$DOMAIN/$URL"
    echo "- Username       : admin"
    echo "- Password       : admin"
    echo "- Please change admin password"
    ;;
esac
echo "-------------------------------------------------------------------------------"
echo "Following DB parameters are allowed:"
echo "    # config setprop $MYSQLDB PublicAccess local/global"
echo " "
echo "Don't forget to apply modifications with following commands:"
echo "    # expand-template /etc/httpd/conf/httpd.conf"
echo "    # svc -h /service/httpd-e-smith"
echo " "
echo "For more details, see http://wiki.contribs.org/Joomla"
echo "-------------------------------------------------------------------------------"


			     
%preun
INSTALLDIR=/usr/share/doc/Joomla-1.5.1/Sources
if [ $1 = 0 ] ; then
  mv $INSTALLDIR/DO_NOT_USE_OR_DELETE/Joomla-Full-Uninstall.sh /root/
fi

%postun
if [ $1 = 0 ] ; then
  echo "Restarting services..."
  /sbin/e-smith/expand-template /etc/httpd/conf/httpd.conf
  /usr/local/bin/svc -h /service/httpd-e-smith
  echo " "
  echo "Uninstallation finished!"
  echo "If you want to completly remove it (installation files and MySQL user+database)"
  echo "please issue the following command at the prompt:"
  echo "# sh /root/Joomla-Full-Uninstall.sh"
fi

%files -f %{name}-%{version}-filelist

%defattr(-,root,root)
 
                                                                                     
